#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

vector<vector<int>> g;
vector<int> visited;
vector<int> wave;

void bfs(int i) {
	queue<int> q;
	q.push(i);
	wave[i] = 0;
	while (q.size()) {
		int u = q.front();
		q.pop();
		visited[u] = true;
		for (int v : g[u]) {
			if (!visited[v]) {
				wave[v] = min(wave[u] + 1, wave[v]);
				q.push(v);
			}
		}
	}
}


int main()
{
	int n, k, t; cin >> n >> k >> t;
	if (t == 1) {
		g.resize(n);
		wave.resize(n, 2e9);
		visited.resize(n);
		vector<int> ans(n);
		for (int i = 0; i < n - 1; i++) {
			int u, v; cin >> u >> v; u--; v--;
			g[u].push_back(v);
			g[v].push_back(u);
		}
		for (int i = 0; i < n; i++) {
			wave.assign(n, 2e9);
			visited.assign(n, false);
			bfs(i);
			sort(wave.begin(), wave.end());
			int ind = n - 1;
			int nk = k;

			while (nk) {
				wave[ind] = min(wave[ind], 1);
				ind--;
				nk--;
			}
			sort(wave.begin(), wave.end());

			ans[i] = wave[n - 1];
		}

		for (int i : ans) cout << i << ' ';

	}
	else {
		g.resize(n);
		wave.resize(n, 2e9);
		visited.resize(n, false);
		vector<int> ans(n);
		for (int i = 0; i < n - 1; i++) {
			int u, v; cin >> u >> v; u--; v--;
			g[u].push_back(v);
			g[v].push_back(u);
		}
		bfs(0);
		sort(wave.begin(), wave.end());
		int ind = n - 1;
		int nk = k;
		while (nk) {
			wave[ind] = min(wave[ind], 1);
			ind--;
			nk--;
		}
		sort(wave.begin(), wave.end());
		cout << wave[n - 1];
		
		
	}
	
}
