#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

vector<vector<long long>> g;
vector<long long> visited;
vector<long long> wave;

void bfs(long long i) {
	queue<long long> q;
	q.push(i);
	wave[i] = 0;
	while (q.size()) {
		long long u = q.front();
		q.pop();
		visited[u] = true;
		for (long long v : g[u]) {
			if (!visited[v]) {
				wave[v] = min(wave[u] + 1, wave[v]);
				q.push(v);
			}
		}
	}
}


int main()
{
	long long er = 1;
	long long n, k, t; cin >> n >> k >> t;
	if (t == 1) {
		g.resize(n);
		wave.resize(n, 2e9);
		visited.resize(n);
		vector<long long> ans(n);
		for (long long i = 0; i < n - 1; i++) {
			long long u, v; cin >> u >> v; u--; v--;
			g[u].push_back(v);
			g[v].push_back(u);
		}
		for (long long i = 0; i < n; i++) {
			wave.assign(n, 2e9);
			visited.assign(n, false);
			bfs(i);
			sort(wave.begin(), wave.end());
			long long ind = n - 1;
			long long nk = k;

			while (nk) {

				if (ind) wave[ind] = min(wave[ind], er);
				ind--;
				nk--;
			}
			sort(wave.begin(), wave.end());

			ans[i] = wave[n - 1];
		}

		for (int i : ans) cout << i << ' ';

	}
	else {
		g.resize(n);
		wave.resize(n, 2e9);
		visited.resize(n, false);
		vector<long long> ans(n);
		for (long long i = 0; i < n - 1; i++) {
			long long u, v; cin >> u >> v; u--; v--;
			g[u].push_back(v);
			g[v].push_back(u);
		}
		bfs(0);
		sort(wave.begin(), wave.end());
		long long ind = n - 1;
		long long nk = k;
		while (nk) {
			if (ind) wave[ind] = min(wave[ind], er);
			ind--;
			nk--;
		}
		sort(wave.begin(), wave.end());
		cout << wave[n - 1];
		
		
	}
	
}
